<?php
/**
 * CustomerInfoForCreate
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\CrmClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * CRM
 *
 * Управление клиентами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\CrmClient\Dto;

use \ArrayAccess;
use \Ensi\CrmClient\ObjectSerializer;

/**
 * CustomerInfoForCreate Class Doc Comment
 *
 * @category Class
 * @package  Ensi\CrmClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class CustomerInfoForCreate implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'CustomerInfoForCreate';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'customer_id' => 'int',
        'kpi_sku_count' => 'int',
        'kpi_sku_price_sum' => 'int',
        'kpi_order_count' => 'int',
        'kpi_shipment_count' => 'int',
        'kpi_delivered_count' => 'int',
        'kpi_delivered_sum' => 'int',
        'kpi_refunded_count' => 'int',
        'kpi_refunded_sum' => 'int',
        'kpi_canceled_count' => 'int',
        'kpi_canceled_sum' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'customer_id' => null,
        'kpi_sku_count' => null,
        'kpi_sku_price_sum' => null,
        'kpi_order_count' => null,
        'kpi_shipment_count' => null,
        'kpi_delivered_count' => null,
        'kpi_delivered_sum' => null,
        'kpi_refunded_count' => null,
        'kpi_refunded_sum' => null,
        'kpi_canceled_count' => null,
        'kpi_canceled_sum' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'customer_id' => false,
        'kpi_sku_count' => true,
        'kpi_sku_price_sum' => true,
        'kpi_order_count' => true,
        'kpi_shipment_count' => true,
        'kpi_delivered_count' => true,
        'kpi_delivered_sum' => true,
        'kpi_refunded_count' => true,
        'kpi_refunded_sum' => true,
        'kpi_canceled_count' => true,
        'kpi_canceled_sum' => true
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'customer_id' => 'customer_id',
        'kpi_sku_count' => 'kpi_sku_count',
        'kpi_sku_price_sum' => 'kpi_sku_price_sum',
        'kpi_order_count' => 'kpi_order_count',
        'kpi_shipment_count' => 'kpi_shipment_count',
        'kpi_delivered_count' => 'kpi_delivered_count',
        'kpi_delivered_sum' => 'kpi_delivered_sum',
        'kpi_refunded_count' => 'kpi_refunded_count',
        'kpi_refunded_sum' => 'kpi_refunded_sum',
        'kpi_canceled_count' => 'kpi_canceled_count',
        'kpi_canceled_sum' => 'kpi_canceled_sum'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'customer_id' => 'setCustomerId',
        'kpi_sku_count' => 'setKpiSkuCount',
        'kpi_sku_price_sum' => 'setKpiSkuPriceSum',
        'kpi_order_count' => 'setKpiOrderCount',
        'kpi_shipment_count' => 'setKpiShipmentCount',
        'kpi_delivered_count' => 'setKpiDeliveredCount',
        'kpi_delivered_sum' => 'setKpiDeliveredSum',
        'kpi_refunded_count' => 'setKpiRefundedCount',
        'kpi_refunded_sum' => 'setKpiRefundedSum',
        'kpi_canceled_count' => 'setKpiCanceledCount',
        'kpi_canceled_sum' => 'setKpiCanceledSum'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'customer_id' => 'getCustomerId',
        'kpi_sku_count' => 'getKpiSkuCount',
        'kpi_sku_price_sum' => 'getKpiSkuPriceSum',
        'kpi_order_count' => 'getKpiOrderCount',
        'kpi_shipment_count' => 'getKpiShipmentCount',
        'kpi_delivered_count' => 'getKpiDeliveredCount',
        'kpi_delivered_sum' => 'getKpiDeliveredSum',
        'kpi_refunded_count' => 'getKpiRefundedCount',
        'kpi_refunded_sum' => 'getKpiRefundedSum',
        'kpi_canceled_count' => 'getKpiCanceledCount',
        'kpi_canceled_sum' => 'getKpiCanceledSum'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('customer_id', $data, null);
        $this->setIfExists('kpi_sku_count', $data, null);
        $this->setIfExists('kpi_sku_price_sum', $data, null);
        $this->setIfExists('kpi_order_count', $data, null);
        $this->setIfExists('kpi_shipment_count', $data, null);
        $this->setIfExists('kpi_delivered_count', $data, null);
        $this->setIfExists('kpi_delivered_sum', $data, null);
        $this->setIfExists('kpi_refunded_count', $data, null);
        $this->setIfExists('kpi_refunded_sum', $data, null);
        $this->setIfExists('kpi_canceled_count', $data, null);
        $this->setIfExists('kpi_canceled_sum', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets customer_id
     *
     * @return int|null
     */
    public function getCustomerId()
    {
        return $this->container['customer_id'];
    }

    /**
     * Sets customer_id
     *
     * @param int|null $customer_id Идентификатор пользователя
     *
     * @return $this
     */
    public function setCustomerId($customer_id)
    {


        /*if (is_null($customer_id)) {
            throw new \InvalidArgumentException('non-nullable customer_id cannot be null');
        }*/
        $this->container['customer_id'] = $customer_id;

        return $this;
    }

    /**
     * Gets kpi_sku_count
     *
     * @return int|null
     */
    public function getKpiSkuCount()
    {
        return $this->container['kpi_sku_count'];
    }

    /**
     * Sets kpi_sku_count
     *
     * @param int|null $kpi_sku_count Колличетсво купленных товаров
     *
     * @return $this
     */
    public function setKpiSkuCount($kpi_sku_count)
    {

        if (is_null($kpi_sku_count)) {
            array_push($this->openAPINullablesSetToNull, 'kpi_sku_count');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('kpi_sku_count', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['kpi_sku_count'] = $kpi_sku_count;

        return $this;
    }

    /**
     * Gets kpi_sku_price_sum
     *
     * @return int|null
     */
    public function getKpiSkuPriceSum()
    {
        return $this->container['kpi_sku_price_sum'];
    }

    /**
     * Sets kpi_sku_price_sum
     *
     * @param int|null $kpi_sku_price_sum Сумма цен купленных товаров
     *
     * @return $this
     */
    public function setKpiSkuPriceSum($kpi_sku_price_sum)
    {

        if (is_null($kpi_sku_price_sum)) {
            array_push($this->openAPINullablesSetToNull, 'kpi_sku_price_sum');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('kpi_sku_price_sum', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['kpi_sku_price_sum'] = $kpi_sku_price_sum;

        return $this;
    }

    /**
     * Gets kpi_order_count
     *
     * @return int|null
     */
    public function getKpiOrderCount()
    {
        return $this->container['kpi_order_count'];
    }

    /**
     * Sets kpi_order_count
     *
     * @param int|null $kpi_order_count Колличетсво офрмленных заказов
     *
     * @return $this
     */
    public function setKpiOrderCount($kpi_order_count)
    {

        if (is_null($kpi_order_count)) {
            array_push($this->openAPINullablesSetToNull, 'kpi_order_count');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('kpi_order_count', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['kpi_order_count'] = $kpi_order_count;

        return $this;
    }

    /**
     * Gets kpi_shipment_count
     *
     * @return int|null
     */
    public function getKpiShipmentCount()
    {
        return $this->container['kpi_shipment_count'];
    }

    /**
     * Sets kpi_shipment_count
     *
     * @param int|null $kpi_shipment_count Колличетсво оформленных отправок
     *
     * @return $this
     */
    public function setKpiShipmentCount($kpi_shipment_count)
    {

        if (is_null($kpi_shipment_count)) {
            array_push($this->openAPINullablesSetToNull, 'kpi_shipment_count');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('kpi_shipment_count', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['kpi_shipment_count'] = $kpi_shipment_count;

        return $this;
    }

    /**
     * Gets kpi_delivered_count
     *
     * @return int|null
     */
    public function getKpiDeliveredCount()
    {
        return $this->container['kpi_delivered_count'];
    }

    /**
     * Sets kpi_delivered_count
     *
     * @param int|null $kpi_delivered_count Колличетсво досталенных
     *
     * @return $this
     */
    public function setKpiDeliveredCount($kpi_delivered_count)
    {

        if (is_null($kpi_delivered_count)) {
            array_push($this->openAPINullablesSetToNull, 'kpi_delivered_count');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('kpi_delivered_count', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['kpi_delivered_count'] = $kpi_delivered_count;

        return $this;
    }

    /**
     * Gets kpi_delivered_sum
     *
     * @return int|null
     */
    public function getKpiDeliveredSum()
    {
        return $this->container['kpi_delivered_sum'];
    }

    /**
     * Sets kpi_delivered_sum
     *
     * @param int|null $kpi_delivered_sum Сумма цен доставленных
     *
     * @return $this
     */
    public function setKpiDeliveredSum($kpi_delivered_sum)
    {

        if (is_null($kpi_delivered_sum)) {
            array_push($this->openAPINullablesSetToNull, 'kpi_delivered_sum');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('kpi_delivered_sum', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['kpi_delivered_sum'] = $kpi_delivered_sum;

        return $this;
    }

    /**
     * Gets kpi_refunded_count
     *
     * @return int|null
     */
    public function getKpiRefundedCount()
    {
        return $this->container['kpi_refunded_count'];
    }

    /**
     * Sets kpi_refunded_count
     *
     * @param int|null $kpi_refunded_count Колличетсво возвращенных
     *
     * @return $this
     */
    public function setKpiRefundedCount($kpi_refunded_count)
    {

        if (is_null($kpi_refunded_count)) {
            array_push($this->openAPINullablesSetToNull, 'kpi_refunded_count');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('kpi_refunded_count', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['kpi_refunded_count'] = $kpi_refunded_count;

        return $this;
    }

    /**
     * Gets kpi_refunded_sum
     *
     * @return int|null
     */
    public function getKpiRefundedSum()
    {
        return $this->container['kpi_refunded_sum'];
    }

    /**
     * Sets kpi_refunded_sum
     *
     * @param int|null $kpi_refunded_sum Сумма цен возвращенных
     *
     * @return $this
     */
    public function setKpiRefundedSum($kpi_refunded_sum)
    {

        if (is_null($kpi_refunded_sum)) {
            array_push($this->openAPINullablesSetToNull, 'kpi_refunded_sum');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('kpi_refunded_sum', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['kpi_refunded_sum'] = $kpi_refunded_sum;

        return $this;
    }

    /**
     * Gets kpi_canceled_count
     *
     * @return int|null
     */
    public function getKpiCanceledCount()
    {
        return $this->container['kpi_canceled_count'];
    }

    /**
     * Sets kpi_canceled_count
     *
     * @param int|null $kpi_canceled_count Колличетсво отмененных
     *
     * @return $this
     */
    public function setKpiCanceledCount($kpi_canceled_count)
    {

        if (is_null($kpi_canceled_count)) {
            array_push($this->openAPINullablesSetToNull, 'kpi_canceled_count');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('kpi_canceled_count', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['kpi_canceled_count'] = $kpi_canceled_count;

        return $this;
    }

    /**
     * Gets kpi_canceled_sum
     *
     * @return int|null
     */
    public function getKpiCanceledSum()
    {
        return $this->container['kpi_canceled_sum'];
    }

    /**
     * Sets kpi_canceled_sum
     *
     * @param int|null $kpi_canceled_sum Сумма цен отмененных
     *
     * @return $this
     */
    public function setKpiCanceledSum($kpi_canceled_sum)
    {

        if (is_null($kpi_canceled_sum)) {
            array_push($this->openAPINullablesSetToNull, 'kpi_canceled_sum');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('kpi_canceled_sum', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['kpi_canceled_sum'] = $kpi_canceled_sum;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


